﻿package {
	import flash.display.MovieClip;
	import flash.events.*;
	import caurina.transitions.Tweener;
	
	public class Bacteria extends MovieClip{
		private var horizontal_move_speed:Number;
		private var horizontal_move_direction:Number;
		
		private var bacteria_type:Number;
		
		private var angle:Number=0;
		private var radians:Number;
		
		public function Bacteria(){
			// class constructor
			addEventListener(Event.ADDED_TO_STAGE, initBacteria);
			addEventListener(Event.REMOVED_FROM_STAGE, removeListeners);
			addEventListener(Event.ENTER_FRAME, moveBacteria);
			addEventListener(MouseEvent.CLICK, destroyVisual);
		}
		
		public function initBacteria(event:Event):void {
			explosion_mc.visible = false;
			
			bacteria_holder_mc.gotoAndStop(Math.round(Math.random() * 6 + 1));
			horizontal_move_direction = Math.random() > .5 ? 1 : -1;
			horizontal_move_speed = Math.round(3 + Math.random()*4);
			bacteria_type = Math.round(Math.random()*3 + 1);
			this.cacheAsBitmap = true;
			
			radians = 180/Math.PI; // рассчитаем отношение радиан к градусам (математичнеские функции, в которых используютсЯ углы на входе требуют значение в радианах)
		}
		
		public function destroyVisual(event:MouseEvent):void {
			event.stopImmediatePropagation();
			Tweener.addTween(bacteria_holder_mc, {width:1, height:1, time:.5, delay:0, transition:"easeOutCubic", onComplete:destroyBacteria});
			
			explosion_mc.visible = true;
			explosion_mc.play();
		}
		
		private function destroyBacteria():void {
			dispatchEvent(new Event("destroyBacteria", true))
			parent.removeChild(this);
		}
		
		public function moveBacteria(event:Event):void {
			this.x += horizontal_move_speed * horizontal_move_direction;
			if (this.x + this.width >= stage.stageWidth - 10){
				this.x = stage.stageWidth - this.width - 11;
				horizontal_move_direction = -1;
			}else if (this.x <= 10){
				this.x = 11;
				horizontal_move_direction = 1;
			}
			angle += 5;
			var r_ang = angle/radians;
			this.y = this.y + 2  * Math.sin(r_ang);
		}
		
		private function removeListeners(event:Event):void {
			trace("Listeners removed " + this);
			removeEventListener(Event.ADDED_TO_STAGE, initBacteria);
			removeEventListener(Event.REMOVED_FROM_STAGE, removeListeners);
			removeEventListener(Event.ENTER_FRAME, moveBacteria);
			removeEventListener(MouseEvent.CLICK, destroyVisual);
		}
	}
}